unit globals;

{$INCLUDE main_include.inc}

interface
	uses three_d, graph_constants;
	
	{$i memory_addr.inc}

	// ilosc obiektow mogacych istniec w swiecie
	{$ifndef TWO_OBJECTS}
		{$ifndef ALL_OBJECTS}
		const MAX_OBJ_INST_AMOUNT = 1;
		const MAX_DEF_AMOUNT = 1;
		const EXPLOSION_INSTANCE_INDEX = 0;
		{$endif}
	{$endif}
	{$ifdef TWO_OBJECTS}
		{$ifndef ALL_OBJECTS}
		const MAX_OBJ_INST_AMOUNT = 2;
		const MAX_DEF_AMOUNT = 3; // bo idx 1 to eksplozja niewidoczna
		const EXPLOSION_INSTANCE_INDEX = 0;
		{$else}
		const MAX_OBJ_INST_AMOUNT = 16;
		const MAX_DEF_AMOUNT = 9;
		const EXPLOSION_INSTANCE_INDEX = 0; // liczony od 0
		{$endif}
	{$endif}
	
	const RUNWAY_DEF_NO 		= 0;
	const GRND_EXPL_DEF_NO 		= 1;
	const TANK_DEF_NO 			= 2;
	const FIGHTER_DEF_NO 		= 3;
	const FOREST_DEF_NO 		= 4;
	const BIGMOUNTAIN_DEF_NO 	= 5;
	const FARM_DEF_NO 			= 6;
	const RADAR_DEF_NO 			= 7;
	const SAM_DEF_NO 			= 8;
	
	const INVINCIBLE_HP = 255;
	
	const MAX_THROTTLE = 80; // bez dopalacza
	const AFTERBURNER_THROTTLE = 120;
	const THROTTLE_CHANGE = 10;


// TODO te kolory to z def type
	// const g_obj_def_colors : array[0..8] of byte = (GREY, RED, GREY, GREY, GREEN, GREEN, GREEN, GREY, GREY); // poniewaz 4 kolory to dalo by sie gesciej
	
	type BytePtr = ^Byte;
	type IntegerPtr = ^Integer;
	
	{$ifdef RENDER_STATS}
		var g_stats_far : byte;	// liczba dalekich obiektów 3d rysowanych (jako kropki)
		var g_stats_3d_obj : byte;		// liczba pełnych obiektów 3d rysowanych
		var g_Stats_points : byte; // liczba obróconych punktów 3d obiektów
	{$endif}
	
	
	// joystick
	const joy_up = 1;
	const joy_down = 2;
	const joy_left = 4;
	const joy_right = 8;

	var g_key : Byte;
	var g_joyState : Byte;
	var g_joyFire : Byte;
	
	var g_farS : WorldVector3DSType;

	// patrz też adresy w modfastgraph
	
	// koniec misji - rezultat, <>0 powoduje zakonczenie
	// 0 continue, pozostale kody, indeks w tabeli g_outcomes_tab
	var g_sim_Outcome : byte = 0;
	
	const SIM_OUTCOME_CONTINUE	 					= 0;
	const SIM_OUTCOME_NO_FUEL						= 1;
	const SIM_OUTCOME_GROUND_CRASH_PITCH			= 2;
	const SIM_OUTCOME_GROUND_CRASH_ROLL				= 3;
	const SIM_OUTCOME_GROUND_CRASH_LANDING_SPD		= 4;
	const SIM_OUTCOME_GROUND_CRASH_VSPD				= 5;
	const SIM_OUTCOME_GROUND_CRASH_GEAR				= 6;
	const SIM_OUTCOME_QUIT							= 7; // player quit
	
	const g_sim_outcomes_tab : array[0..7] of String = ('OK'~, 'NO FUEL'~,'PITCH'~,'ROLL'~, 'GSPD'~, 'VSPD'~,'GEAR'~, 'QUIT'~);
	
	var g_time_to_fire_next_weapon : byte = 0;
	
	var g_wpn_CurrentWeapon : byte;
	const WPN_UNGUIDED_MISSILE		= 0;
	const WPN_A2G_MISSILE			= 1;
	
	const WPN_AMOUNT 				= 2;
	
	// liczba pocisków
	var g_wpn_amount_tab : array[0.. WPN_AMOUNT -1] of byte;
	
	var g_flt_throttle : smallint;
	var g_flt_FuelAmount : word;
	var g_flt_spd : smallint;
	var g_flt_geardown : boolean;
	var g_sim_MapZoomLevel: byte;
	
	const FLIGHT_MODE_NAV = byte('N') - 48;
	const FLIGHT_MODE_A2A = byte('A') - 48;
	const FLIGHT_MODE_A2G = byte('G') - 48;

	var g_sim_flightMode : byte;
	
		
	const MFD_MODE_0 = 0;
	const MFD_MODE_1 = 1;
	const MFD_MODE_2 = 2;
	const MFD_MODES_AMOUNT = 3;
	
	var g_sim_LeftMfdMode : byte;
	var g_sim_RightMfdMode : byte;
	var g_sim_CurrTrg : shortint; // -1 to brak
	var g_sim_CurrTrgPtr : ObjInstanceSTypePtr; // wskaźnik instancji

	// TODO 2023 smallint to marnotrastwo miejsca (Ale wydajnosc niegorsza)
	var SinTab : array [0..359] of smallint absolute TRIG_TAB_ADDR;
	
	var CosTab : array [0..359] of smallint absolute TRIG_TAB_ADDR + 2*360;
	
	var ArcSinTab : array [0 .. 201 - 1] of SHORTINT absolute TRIG_TAB_ADDR + 4 * 360;
	
	var TanTab : array [0 .. 89] of smallint absolute TRIG_TAB_ADDR + 4 * 360 + 201;
	
	var sqrtab : array [0..257-1] of word absolute TRIG_TAB_ADDR + 4 * 360 + 201 + 2 * 90;
	
	// globalna tablica na obrocone (ale bez przesuwania bo to robi się już przy renderowaniu) w swiecie punkty instancji obiektow
	// trzyma wartosci x,y,z (3) vertexow
	// TODO 2023 docelowo przerobić można na osobne wymiary
	// poza obiektami swiata sa tu tez eksplozje itp
	var g_vertex_rots_tab : array[0.. (3 * MAX_VERTEX_AMOUNT * MAX_OBJ_INST_AMOUNT) - 1] of RenderCoordType absolute data_address;

	// pomocnicza dla view_object - widoczność vertexa
	var g_vertex_vis_tab : array[0..MAX_VERTEX_AMOUNT-1] of byte absolute data_address + (3 * MAX_VERTEX_AMOUNT * MAX_OBJ_INST_AMOUNT * RenderCoordTypeSIZE);
	
	// pomocnicza dla view_object - rotSTab x,y,z
	var g_view_object_rot_x : array[0..MAX_VERTEX_AMOUNT - 1] of RenderCoordType absolute data_address + (3 * MAX_VERTEX_AMOUNT * MAX_OBJ_INST_AMOUNT * RenderCoordTypeSIZE) + MAX_VERTEX_AMOUNT;
	var g_view_object_rot_y : array[0..MAX_VERTEX_AMOUNT - 1] of RenderCoordType absolute data_address + (3 * MAX_VERTEX_AMOUNT * MAX_OBJ_INST_AMOUNT * RenderCoordTypeSIZE) + MAX_VERTEX_AMOUNT + MAX_VERTEX_AMOUNT * RenderCoordTypeSIZE;
	var g_view_object_rot_z : array[0..MAX_VERTEX_AMOUNT - 1] of RenderCoordType absolute data_address + (3 * MAX_VERTEX_AMOUNT * MAX_OBJ_INST_AMOUNT * RenderCoordTypeSIZE) + MAX_VERTEX_AMOUNT + 2 * MAX_VERTEX_AMOUNT * RenderCoordTypeSIZE;
	
	// pomocnicze view_object pointSTab
	var g_pt_x_tab : array[0..MAX_VERTEX_AMOUNT-1] of Coord2DType absolute data_address + (3 * MAX_VERTEX_AMOUNT * MAX_OBJ_INST_AMOUNT * RenderCoordTypeSIZE) + MAX_VERTEX_AMOUNT + 3 * MAX_VERTEX_AMOUNT * RenderCoordTypeSIZE;
	var g_pt_y_tab : array[0..MAX_VERTEX_AMOUNT-1] of Coord2DType absolute data_address
		+ (3 * MAX_VERTEX_AMOUNT * MAX_OBJ_INST_AMOUNT * RenderCoordTypeSIZE)
		+ MAX_VERTEX_AMOUNT 
		+ 3 * MAX_VERTEX_AMOUNT * RenderCoordTypeSIZE
		+ MAX_VERTEX_AMOUNT * Coord2DTypeSIZE;


	
	// tablica definicji obiektow - nie wiem czy potrzebna bo kazda instancja i tak trzyma referencje
	var g_obj_def_stab : array [0..MAX_DEF_AMOUNT - 1] of ^XObjDefSType; 
	
	// tablica instancji obiektów 3D w świecie
	var g_obj_inst_tab : array[0..MAX_OBJ_INST_AMOUNT - 1] of POINTER; // ^ObjInstanceSType
	
	
	const GLOBAL_OBJ_INST_AMOUNT = 40;
	// rezerwacja pamięci na te wszystkie instancje
	const BUFF_SIZE = GLOBAL_OBJ_INST_AMOUNT * sizeof(ObjInstanceSType);
	var g_all_objects_tab : array [0..BUFF_SIZE] of byte absolute high_data_address; // TODO absolute addres pod romem

	// alokacja mapięci dla obiektów instancji
	{var g_obj_inst_0 : ObjInstanceSType;
	{-ifdef TWO_OBJECTS
		var g_obj_inst_1 : ObjInstanceSType;
		{-ifdef ALL_OBJECTS
			var g_obj_inst_2 : ObjInstanceSType;
			var g_obj_inst_3 : ObjInstanceSType;
			var g_obj_inst_4 : ObjInstanceSType;
			var g_obj_inst_5 : ObjInstanceSType;
			var g_obj_inst_6 : ObjInstanceSType;
			var g_obj_inst_7 : ObjInstanceSType; // eksplozja
		{-endif
	{-endif
	}
	
	var g_posS : ViewPointSType;


	// ----------- bullets
	const MAX_BULLET_AMOUNT = 5;
	
	type BulletKindEType = (CANNON_BULLET,BOMB_BULLET,ROCKET_BULLET,AAA_GUN_BULLET,GROUND_EXPLOSION_BULLET,AIR_EXPLOSION_BULLET);
	
	{type bulletSType = packed record
		posS : WorldVector3DSType;
		vS : WorldVector3DSType;
		// time : word; -> bulletTimeSTabType
		// kindE : Byte; -> bulletKindSTabType
	end;}
	
	// type bulletSTypePtr = ^bulletSType;
	
	var g_bullet_pos_0 : WorldVector3DSType; // samych wartosci nie trzeba inicjalizowac
	var g_bullet_pos_1 : WorldVector3DSType;
	var g_bullet_pos_2 : WorldVector3DSType;
	var g_bullet_pos_3 : WorldVector3DSType;
	var g_bullet_pos_4 : WorldVector3DSType;

	var g_bullet_vS_0 : WorldVector3DSType;
	var g_bullet_vS_1 : WorldVector3DSType;
	var g_bullet_vS_2 : WorldVector3DSType;
	var g_bullet_vS_3 : WorldVector3DSType;
	var g_bullet_vS_4 : WorldVector3DSType;

	const g_bullets_pos_tab : array[0..MAX_BULLET_AMOUNT - 1] of POINTER = (
		@g_bullet_pos_0,
		@g_bullet_pos_1,
		@g_bullet_pos_2,
		@g_bullet_pos_3,
		@g_bullet_pos_4
	);
	const g_bullets_vs_tab : array[0..MAX_BULLET_AMOUNT - 1] of POINTER = (
		@g_bullet_vS_0,
		@g_bullet_vS_1,
		@g_bullet_vS_2,
		@g_bullet_vS_3,
		@g_bullet_vS_4
	);
	
	var g_bullets_time_tab : array[0..MAX_BULLET_AMOUNT - 1] of Byte = (0,0,0,0,0); // TODO 2023 przeniesc inicjalizacje
	var g_bullets_kind_tab : array[0..MAX_BULLET_AMOUNT - 1] of Byte; // nie trzeba inicjalizowac

	// -------------- missiles --------------
	const MAX_MISSILE_AMOUNT = 5;

	var g_missile_pos_0 : WorldVector3DSType; // samych wartosci nie trzeba inicjalizowac
	var g_missile_pos_1 : WorldVector3DSType;
	var g_missile_pos_2 : WorldVector3DSType;
	var g_missile_pos_3 : WorldVector3DSType;
	var g_missile_pos_4 : WorldVector3DSType;
	
	var g_missile_dizzy_time : array[0..MAX_MISSILE_AMOUNT - 1] of Byte;
	var g_missile_pos_tab : array[0..MAX_BULLET_AMOUNT - 1] of POINTER = (
		@g_missile_pos_0,
		@g_missile_pos_1,
		@g_missile_pos_2,
		@g_missile_pos_3,
		@g_missile_pos_4
	);
	
	// 0 to nie istnieje
	// z kazdym procesowaniem zmniejsza sie o 1
	var g_missile_hp_tab : array[0..MAX_BULLET_AMOUNT - 1] of byte;
	// wskaźniki do celów
	// TODO 2023 Uwaga może przestać istnieć!
	var g_missile_target_pos_tab : array[0..MAX_BULLET_AMOUNT - 1] of POINTER;
	// czy cel jeszcze istnieje
	var g_missile_target_hp_tab   : array[0..MAX_BULLET_AMOUNT - 1] of POINTER;
	var g_missile_alpha_tab  : array[0..MAX_BULLET_AMOUNT - 1] of smallint;
	var g_missile_beta_tab   : array[0..MAX_BULLET_AMOUNT - 1] of smallint;
	
	procedure cancelCurrentTargetLock;
	
implementation

	procedure cancelCurrentTargetLock;
	begin
		g_sim_CurrTrg := -1;
		g_sim_CurrTrgPtr := POINTER($0);
	end;

end.