unit graph_pageflip;

interface
	procedure check_data_integrity;
	
	//g_visible_page : POINTER;
	//g_drawn_page : POINTER;
	procedure show_message(lineNo : byte; m : string);
	procedure panic(m : string);
	
	procedure clear_act_page;
	procedure clear_text_part; inline;
	procedure flip_screen;
	//procedure init_paged_graphics;
	
	{procedure loc_line(x1,y1,x2,y2: smallint); }
	// procedure loc_PutPixel(x,y: smallint); 
	procedure init_modgraph;
	{$ifdef RENDER_STATS}
		procedure reset_render_Stats; inline;
		procedure display_render_stats; inline;
	{$endif}
	
	function Atascii2InvAntic(s: string):string;
	procedure CRT_WriteInv(v : integer);

implementation
	uses atari, sysutils, b_crt, globals,global_Vars,graph_constants, modfastgraph;
	
	
	var // g_dl_addr : word; // display list address
		g_pg : Byte = 0; // numer strony 0 lub 1 w page flipping, TODO moze da sie pozbyc?
	
	
	{procedure loc_line(x1,y1,x2,y2: smallint); 
	begin;
		fline(x1,y1,x2,y2); // uwaga range check
	end;}
	
	procedure check_data_integrity;
	var chk : word;
	n : word;
	begin;
		chk := 0;
	{	for n := MODGRAPH_LINE_COLOR_BITS_ADDR to MODGRAPH_LINE_COLOR_BITS_ADDR + $fff do begin
			inc(chk, peek(n));
		end;
		show_message(2, 'linecrc '~);
		CRT_Write(chk);
		CRT_Write('  #'~);}
	end;


{$ifdef DEBUG_CHECKS}
	procedure verify_tables;
	var
	counter : word;
	chk : word;
	begin;
		if ((arcsintab[0] <> -90) OR
			(costab[0] <> 256) OR
			(TanTab[0] <> 0) OR
			(TanTab[89] <> 14666) OR
			(sqrtab[257] <> 65535))
		then begin
			CRT_Write('tab ver err'~);
			CRT_Readkey;
			exit;
		end;
		chk :=0; // suma fmula
		for counter:=$a300 to $a300 + $7ff do
		begin
			inc(chk, peek(counter)); // 41988
		end;
		CRT_Write(chk);
		if (chk <>41988) then panic('fmul err'~);
		CRT_Write(' tab ver OK'~);
		check_data_integrity;
		CRT_readkey;
	end;
{$endif}

{
procedure init_dlist_mode_6;
begin;
	dpoke(dlist_address + 4, word(g_screen_pages_tab[0])); // video ram
	dpoke(dlist_address + $56, txt_lines_Address); // text ram
	dpoke(dlist_address + $5A, dlist_address); // ret
end;

procedure init_dlist_mode_7;
begin;
	dpoke(dlist_address + 4, word(g_screen_pages_tab[0])); // video ram
	dpoke(dlist_address + 70, txt_lines_Address); // text ram
	dpoke(dlist_address + 78-2, dlist_address); // ret
	SetActiveBuffer(word(g_screen_pages_tab[0]));
	ScreenHeight := 64;
	// SetClipRect(0,0,SCR_WIDH-1,SCR_HEIGHT-1); // TODO 2023 moze ma sens?
end;}
	
	
procedure flip_screen;
	var p : pointer;
begin;
//FillByte(pointer(g_scr_buf_0), CLR_SCR_SIZE,$00);
	// wyświetl aktywny bufor
	dpoke(dlist_address + 4,  word(g_screen_pages_tab[g_pg]));
	g_pg := 1 XOR g_pg; // wybierz drugi bufor
	p := g_screen_pages_tab[g_pg]; // wazne by pobrać by nie zaczął wypełniać po prostu od pointera gdzie jest ta tablica
	SetActiveBuffer(word(p)); // rysuj na buf 0
	FillByte(p,CLR_SCR_SIZE, 0); // TODO delme

end;

procedure clear_act_page;
	var p : pointer;
begin
	p := g_screen_pages_tab[g_pg];
	FillByte(p,CLR_SCR_SIZE, 0); // wyczyszczenie aktualnego ekranu
end;

procedure clear_text_part; inline;
begin
	FillByte(pointer(txt_lines_Address), 8 * 40, 0); // 8 linie po 40
end;

procedure init_modgraph;
	var tst_x, tst_y : smallint;
begin
	// SystemOff;
    //EnableVBLI(@vbli);
    //EnableDLI(@dliInGame);
	// nofastgraph 
	// simplified_init_dlist_mode_7; 
	//InitGraph7; // OLDINIT
	// NEW
	simplified_init_graph7; //InitGraph7; // (7+16); // InitGraph(6+16); //InitGraph(6+16); // niestety nadal wymagany - robi coś magicznego że pisanie po pamięci gdzie są systemowe rzeczy nie robi problemów
	simplified_init_dlist_mode_7;
	// CRT_Init(txt_lines_Address,40,2);
	// bo czytanie resources do pamięci w obszar ROOFF powoduje wyzerowanie DMA
	asm
		lda #$22
		sta sdmctl
		//sta dmactl
	end;

	// modyfikacja listylo(word(@dlist_address));
	//hi(word(@dlist_address));
	//init_dlist_mode_7;
	
	//Poke(COLOR2, 4); // 710 
	//Poke(COLOR4, 0); // 712
	Poke(CRSINH,1);  // cursor inhibit flag, wyłączenie kursora=1
	
	
	
	//Poke(559, $3d); // tod antic?
	//CRT_Readkey;
	
	clear_text_part;
	//poke(g_scr_buf_0,$ff); // debugowo
	//poke(g_scr_buf_1,$ff); // debugowo
	

	//init_line_tabs;
	
	// aktywacja display listy
	// SDLSTL := word(dlist_address); //OLDINIT 
	// TODO SetClipRect(20,20,SCR_WIDH-20,SCR_HEIGHT-20);
	CRT_Init(txt_lines_Address, 40,2); // dla CRT_Write	
	SetColor(1);
	flip_screen;
	// CRT_Readkey;

	
	{CRT_Write('jakis napis '~);
	CRT_Write(arcsintab[0]);
	CRT_Write(':'~);
	CRT_Write(arcsintab[89]);
	CRT_Write(':'~);
	CRT_Write(tantab[89]);
	CRT_Write('SQ '~);
	CRT_Write(sqrtab[1]);
	CRT_Write(':'~);
	CRT_Write(sqrtab[257]);}
	{$ifdef DEBUG_CHECKS}
		verify_tables;
	{$endif}
end;

	
	procedure show_message(lineNo : byte; m : string);
	begin
		CRT_GotoXY(0, lineNo);
		CRT_write(m);
	end;

	procedure panic(m : string);
	begin
		show_message(3, 'PANIC! '~);
		CRT_write(m);
		CRT_readkey;
		CRT_readkey;
	end;
		
	{$ifdef RENDER_STATS}
		procedure reset_render_Stats; inline;
		begin
			g_stats_far :=0;
			g_stats_3d_obj := 0;
			g_Stats_points := 0;
		end;
		
		procedure display_render_stats; inline;
		begin
			CRT_Cursor := right_mfd_top_addr + 1 * CHAR_WIDTH;
			CRT_Write('F'~*);
			CRT_WriteInv(g_stats_far);
			CRT_Write('D'~*);
			CRT_WriteInv(g_stats_3d_obj);
			CRT_Write('P'~*);
			CRT_WriteInv(g_Stats_points);
			CRT_Write(' '~*);
		end;
	{$endif}

	function Atascii2InvAntic(s: string):string;
	var i:byte;
		k : byte;
	begin
		result[0]:=s[0];
		k := byte(s[0]);
		for i:=1 to k do
			result[i]:=char(Atascii2Antic(byte(s[i])) OR 128);
	end;

	procedure CRT_WriteInv(v : integer);
	begin
		CRT_Write(Atascii2InvAntic(IntToStr(v)));
	end;
	

end.