unit three_d;

interface

	// tez w three_d_models.asm:
	const SCL = 300 div 6; // oryg= 300  2023 - skalowanie definicji obiektów 3D
	
	// debugowo by nie startować w 0x0 tylko gdzieś z boku mapy
	const START_X_OFFSET = 0 * SCL;
	const START_Z_OFFSET = 0 * SCL;


	// const CRD_MOD = 8; // TODO bylo 3
	const CRD_SH = 3; // konwersja z "float" x,y,z na normalne x,y,z - shift zamiast mod bo nie chcemy robić div

	const MIN_Y = 2 * SCL;
	
	const MAX_VERTEX_AMOUNT = 17; // TODO 17;
	const MAX_CONN_AMOUNT = 24; // TODO 24;
	
	const VISIBLE_RANGE = 370000; // 2`000`000
	
	const Z_BONUS = 100;
	
	const PERS = 228; // 100; uwaga jeśli będzie mniej niż 64 to shr w dzieleniu wz byłoby 0!
	
	type WorldCoordType = integer; // TODO albo smallint
	type WorldCoordTypePtr = ^integer; // uwaga jeśli wyżej to tu też zmień
	
	type RenderCoordType = smallint; // uwaga w globals sa offset i w asm
	const RenderCoordTypeSIZE = 2; // UWAGA sizeof ( RenderCoordType)
	type RenderCoordPtrType = ^smallint;
	
	type Coord2DType = smallint; //integer;
	const Coord2DTypeSIZE = 2;

	type WorldVector3DSType = packed record
		x : WorldCoordType;
		y : WorldCoordType;
		z : WorldCoordType;
	end;
	
	type WorldVector3DSTypePtr = ^WorldVector3DSType;

	type connSType = packed record
		v1 : byte;
		v2 : byte;
	end;

	type connSTabType = array[0..MAX_CONN_AMOUNT-1] of POINTER; //  ^connSType;


	type ViewPointSType = packed record
		p : WorldVector3DSType;
		
		// to są float wspolrzedne(!)
		fx : integer;
		fy : integer;
		fz : integer;
		
		vx : smallint; // integer;
		vy : smallint; // integer;
		vz : smallint; // integer;
		
		// valpha : smallint;
		// vbeta : smallint;
		vgamma : smallint; // TODO 2023 uporzadkowac pozostale
		
		falpha : smallint;
		fbeta : smallint;
		fgamma : smallint;
		
		alpha : smallint;
		beta : smallint;
		gamma : smallint;
	end;

	type ViewPointSTypePtr = ^ViewPointSType;


	type XObjDefSType = packed record
		name : string[8];
		hp : byte;
		color : byte; // można użyć też do czegoś więcej bo tylko 2 bity potrzebuje na kolor
		VisDetailedDist : WorldCoordType;
		VisFarDist : WorldCoordType;
		VertexAmount : smallint;
		ConnAmount : shortint;
		vertexSTab : POINTER; // ^vector3DSTabType;
		connSTab : POINTER; // ^connSTabType;
	end;
	
	type XObjDefSTypePtr = ^XObjDefSType;
	
	const ACTION_ENEMY_DO_NOTHING = 0;
	const ACTION_ENEMY_MOVE_STRAIGHT = 1;
	const ACTION_ENEMY_RUNWAY_SEARCHING = 10;
	const ACTION_ENEMY_RUNWAY_CHECKING = 11;
	const ACTION_ENEMY_RUNWAY_TRACKING = 12;
	
	const ACTION_FRIENDLY_DO_NOTHING = 128; // wszystkie neutralne są friendly
	
	
	//*** ObjInstanceSType - real implementation of the object in the world
	type ObjInstanceSType = packed record
	  objDefNo : Byte;
	  pS : WorldVector3DSType;
	  vx : shortint; // shiftowane
	  vy : shortint;
	  vz : shortint;
	  alphaFour : smallint; // mozna zmniejszyc i shiftowac *4
	  betaFour : smallint;
	  gammaFour : smallint;
	  // wskazuje na pierwszy vertex w g_vertex_rots_tab dla danego obiektu
	  vertexRotSTab : POINTER; // ^vector3DSTabType; //*** Current outcome of rotation and position
	  hp : byte; // 0 nie renderować
	  action : Byte; // jednocześnieflaga swój-obcy
	  timeToAction : word;
	  range : Byte;
	end;
	
	type ObjInstanceSTypePtr = ^ObjInstanceSType;
	
implementation

end.